
require "grwin"

def x(i, n)
  Math.cos(i * Math::PI * 2.0 / n)
end

def y(i, n)
  Math.sin(i * Math::PI * 2.0 / n)
end


MCPY = 4; MXOR = 7; NLBRS = 0; NLHCH=0
k = 1

n = 16

GrWin.init()
nc = GrWin.ncolor()
GrWin.open(0)
GrWin.vport(0, 0, 1, 1)


GrWin.window(-1.1, -1.1, 1.1, 1.1)
GrWin.setpen(k, -1, -1, MXOR)
for i in 0...(n - 1)
  for j in (i + 1)...n
	k %= nc
	GrWin.setpen(k, -1, -1, -1)
	GrWin.line(x(i, n), y(i, n), x(j, n), y(j,n))
	k += 1
  end
end

GrWin.setpen(-999, -1, -1, MCPY)
GrWin.setbrs(-1, NLBRS, NLHCH)
GrWin.rect(-1.05, -1.05, 1.05, 1.05)
GrWin.ellipse(-1.05, -1.05, 1.05, 1.05)

print "Click and so fill object\n"
print "if you click near the center, quit program.\n"
xm, ym = GrWin.cappnt("Click point")
while xm * xm + ym * ym > 0.1
  k = rand(36)
  ibs = 1 + rand(2)
  ibh = 1 + rand(5)
  GrWin.setbrs(k, ibs, ibh)
  GrWin.flood(xm, ym)
  xm, ym = GrWin.cappnt("Click point")
end

GrWin.quit
