
require "grwin"

PI2 = Math::PI * 2

k = 1
X1, X2, y, N, MN = 0.0, PI2, 1.0, 100, 20
M1, M2, M3, S, SS = 6, 5, 4, 0.1, 0.2

def plotfn(x1, x2, n, mn, mk, k, f)
  print x1, ' ', x2, ' ', n, ' ', mn, ' ', mk
  x0 = x1
  for i in 1..n
	x = i * (x2-x1) / n
	y = f.call(x)
	GrWin.line(x0, f.call(x0), x, f.call(x))
	x0 = x
  end

  for i in 0..mn
	x = i*(x2-x1) / mn
	y = f.call(x)
	k = k+1 % 36
	GrWin.setmrk(mk, -1.0, k, -1, -1)
	GrWin.putmrk(x,y)
  end
end

# ?
def atan(x)
  Math.cos(x) / Math.sin(x)
end

GrWin.init()
GrWin.open(0)
GrWin.window(-0.3, -1.1, PI2 + 0.3, 1.1)
GrWin.line(-0.1, 0.0, PI2 + 0.1, 0.0)
GrWin.settxt(0.1, 0.0, 3, 0, -1, '')
GrWin.puttxt(PI2, -0.02, 'X-axis')
GrWin.line(0.0, 1.1, 0.0, -1.1)
GrWin.settxt(-1.0, 0.25, 2, -1, -1, '')
GrWin.puttxt(-0.02, 1.0, 'Y-axis')
GrWin.setmrk(-1, S, k, -1, -1)

plotfn(X1, X2, N, MN, M1, k, Proc.new { |a| Math.sin(a) } )
plotfn(X1, X2, N, MN, M2, k, Proc.new { |a| Math.cos(a) } )

x = PI2 * 0.425
GrWin.settxt(SS, atan(Math.cos(x+S)/GrWin.aspect(-1))/PI2,
			 + 6, -1, -1, '*')
GrWin.puttxt(x+S, Math.sin(x)+S, 'sin')
x = PI2 * 0.325
#GrWin.settxt(-1.0, Math.atan2(-Math.sin(x+S)/GrWin.aspect(-1), 1)/PI2,
GrWin.settxt(-1.0, atan(-Math.sin(x+S)/GrWin.aspect(-1))/PI2,
			 + 6, -1, -1, '')
GrWin.puttxt(x+S, Math.cos(x)+S, 'cos')
k = k+1 % 36
GrWin.setmrk(M3,S,k,-1,-1)
buff = "#{x} #{y} #{k}"

while x**2+y**2 > 0.1 || GrWin.msgbox('Quit ?') != 1
  ki , x, y = GrWin.cappnt(buff)
  k = k+1 % 36
  GrWin.setmrk(-1, -1.0, k, -1, -1)
  GrWin.putmrk(x,y)
  buff = "#{x} #{y} #{ki} #{k}"
  print "#{x} #{y} #{ki} #{k}\n"
end

GrWin.quitx(0)
