
# require lGrWn0998/demo/jonathan1.bmp
# require lGrWn0998/demo/jonathan2.bmp

require "grwin"

KRED = 13
KGREEN = 14
KBLUE = 16
KWHITE = 19

LSOLID = 1
MCOPYPEN = 4
NOTXORPEN = 11

MX = NOTXORPEN
nbc = 1
ms = 40
NB = []

print "I [1 = rbg}bv, 2 = }[N, 3 = tHg] : "
iball = gets.to_i

GrWin.init()
GrWin.open(0)
llw, llh = GrWin.size(5, 0, 0)
llw, llh = GrWin.size(-1, llw, llh)
wx = llw - 1
wy = llh - 1

GrWin.window(0.0, 0.0, 0.0, 0.0)
GrWin.vwmod(1)
GrWin.setpen(KGREEN, LSOLID, 0, MCOPYPEN)

GrWin.rect(0.0, 0.0, wx, wy)
1.upto(9) do |i|
  GrWin.line(wx / 10 * i, 0.0, wx / 10 * i, wy)
end

1.upto(9) do |i|
  GrWin.line(0.0, wy / 10 * i, wx, wy / 10 * i)
end

case iball
when 1
  NB[1]= GrWin.loadbmp(0, 'jonathan1.bmp')
  GrWin.setbmp(NB[1], 0.0, 0.0, -1, -1, -1)
  w, h, iw, ih, ib, maxnb, fn = GrWin.getbmp(NB[1])
  NB[2] = GrWin.loadbmp(0, 'jonathan2.bmp')
  GrWin.setbmp(NB[2], 0.0, 0.0, -1, -1, -1)
  w = iw / 2.0
  h = ih / 2.0
when 2
  w = wy / 40
  h = wy / 40
  GrWin.setpen(KWHITE, -1, -1, MX)
  GrWin.setmrk(6, 2 * h, KBLUE, -1, MX)
else
  GrWin.settxt(wy/10, 0.0, -1, KBLUE, -1, 'WingDings')
  ch = sprintf "%c", 182
  w = 0
  h = 0
  1.upto(24) do |n|
	GrWin.settxt(-1.0, 15.0*(n-1)/360.0, -1, -1, -1, '')
	ww, hh, xx, yy = GrWin.gettxt(ch)
	if ww > w
	  w = ww
	end
	if hh > h
	  h = hh
	end
	iw, ih = GrWin.ldcsiz(ww, hh)
	iu, iv = GrWin.ldcsiz(xx, yy)
	NB[n] = GrWin.fnt2bmp(0, iw, ih, iu, iv, ch)
	if NB[n] < 0
	  GrWin.quit
	end
	GrWin.setbmp(NB[n], 0.0, 0.0, -1, -1, -1)
  end
  w = w/2
  h = h/2
end

GrWin.anchor(1) # ܂ł̏Ԃی삷

x, y, xe, ye = GrWin.caplin('}EXhbOĂ')
if iball == 1 && xe < x
  nbc = 2
end

dx = ms * (xe - x) / 5000
dy = ms * (ye - y) / 5000
printf "%s = %f\n", 'Xs[h = ', Math.sqrt(dx*dx+dy*dy)/w/ms*100

ilbtn = 0
ivk, ich, nch, ifl = GrWin.kybrd(-1)

while ilbtn == 0 || ivk != 0
  xl = x
  yl = y
  if x + dx > wx - w
	if iball == 1
	  nbc = 2
	end
	dx = -dx
	x = wx - w
  elsif x + dx < w
	if iball == 1
	  nbc = 1
	end
	dx = -dx
	x = w
  else
	x = x + dx
  end

  if y + dy > wy - h
	dy = -dy
	y = wy - h
  elsif y + dy < h
	dy = -dy
	y = h
  else
	y = y + dy
  end

  ilbtn, irbtn, xm, ym = GrWin.mouse()
  ivk, ich, nch, ifl = GrWin.kybrd(-1)
  GrWin.setogn(0, -1) # erase MARK & SLEEP
  case iball
  when 1
	GrWin.putbmp(NB[nbc], x, y, -1)
  when 2
	GrWin.putmrk(x, y)
  else
	nbc = nbc % 24 + 1
	GrWin.putbmp(NB[nbc], x, y, -1)
  end
  GrWin.sleep(ms)
  GrWin.flush(-1)
end

GrWin.quit
