
require "grwin"

ND = 16
IDOPN = []
n, lnw = 2, 0

GrWin.init()

for i in 1..ND
  id = GrWin.openx(0, 0, 0, -1, -1, 1, '')
  if id > 0
	n = n + 1
	IDOPN[n] = id
  else
	puts 'Unable to open window'
	GrWin.quit
  end
end

GrWin.select(IDOPN[1])
GrWin.vport(0.0, 0.0, 1.0, 1.0)
GrWin.window(-0.1, -0.1, 1.1, 1.1)
GrWin.setpen(0, 2, 0, -1)
GrWin.line(0.0, 0.0, 1.0, 1.0)
GrWin.setpen(1, 3, 0, -1)
GrWin.line(0.0, 1.0, 1.0, 0.0)
GrWin.setpen(2, 4, 0, -1)
GrWin.line(0.0, 0.5, 1.0, 0.5)
GrWin.setpen(3, 5, 0, -1)
GrWin.line(0.5, 0.0, 0.5, 1.0)
GrWin.showwn(IDOPN[1], 5)

for i in 2..n
  GrWin.select(IDOPN[i])
  GrWin.vport(0.0, 0.0, 1.0, 1.0)
  GrWin.window(-0.1, -0.1, 1.1, 1.1)
  lnw = lnw + 4
  GrWin.setpen(GrWin.krgb(rand(256),rand(256),rand(256)), 1, lnw, -1)
  dxy = (n-i+1).to_f / n / 2
  GrWin.ellipse(dxy, dxy, 1-dxy, 1-dxy)
end

buff = GrWin.input('# of loops = ')
if buff.size > 0
  for j in 1..buff.to_i
	n.downto(1) do |i|
	  GrWin.select(IDOPN[i])
	  GrWin.arrange(5)
	  GrWin.sleep(30)
	end
	n.downto(1) do |i|
	  GrWin.select(IDOPN[i])
	  GrWin.arrange(5)
	  GrWin.sleep(30)
	end
  end
end

GrWin.arrange(3)
for i in 1..n
  GrWin.select(IDOPN[i])
  GrWin.sleep(100)
  GrWin.clear(-1)
end
 
GrWin.quit
